float timestep;
float rdx;
float dissipation;

//*****************************************************************************//
//*																			  *//
//*****************************************************************************//
texture VelocityMap;
sampler VelocityMapSampler : register(s1) = sampler_state 
{
    texture = <VelocityMap>;    
    magfilter	= POINT; 
	minfilter	= POINT; 
	mipfilter	= POINT; 
	AddressU	= WRAP;  
	AddressV	= WRAP;
};
texture DensityMap;
sampler DensityMapSampler : register(s2) = sampler_state 
{
    texture = <DensityMap>;    
    magfilter	= POINT; 
	minfilter	= POINT; 
	mipfilter	= POINT; 
	AddressU	= WRAP;  
	AddressV	= WRAP;
};
//===============================================================================================
//=	These methods perform texture lookups at the four nearest neighbors of the position s and	=
//=	bilinearly interpolate them.																=
//===============================================================================================
float4 bilerp(sampler tex, float2 s)
{
  float4 st;
  st.x = -rdx;
  st.y = -rdx;
  st.z = rdx;
  st.w = rdx;
  st.xy+=s;
  st.zw+=s;
  
  float2 t = float2(0.5,0.5);
    
  float4 tex11 = tex2D(tex, st.xy);
  float4 tex21 = tex2D(tex, st.zy);
  float4 tex12 = tex2D(tex, st.xw);
  float4 tex22 = tex2D(tex, st.zw);

  // bilinear interpolation
  //return lerp(lerp(tex11, tex21, t.x), lerp(tex12, tex22, t.x), t.y);
  return (tex11+tex21+tex12+tex22)/4;
}

float4 Advect(float2 Coords : TEXCOORD0) : COLOR0
{
	float2 vel = tex2D(VelocityMapSampler, Coords).xy;
	float x = tex2D(DensityMapSampler,Coords).x;
	
	x-=vel.x;
	x-=vel.y;
	
	//x=vel.x;
	
	float4 result=(x,x,x,x);
	return result;
}

technique Technique1
{
    pass Pass1
    {
      
        PixelShader = compile ps_2_0 Advect();
    }
}
